////////////////////////////////////////////////
//
// A ChaloBEST (http://chalobest.in/) initiative
// Author: Nikita (Macgregor Techknowlogy)
// License: GPLv3
//
//
package com.best.ui;

import java.util.List;
import java.util.ArrayList;
import java.util.Vector;

import android.util.AttributeSet;

import android.app.Activity;
import android.app.ListActivity;
import android.app.AlertDialog;
import android.app.ProgressDialog;

import android.os.Bundle;

import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ImageButton;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ListView;
import android.widget.Filterable;
import android.widget.Filter;
import android.widget.AbsListView;

import android.content.Intent;
import android.content.Context;
import android.content.DialogInterface;
import android.content.res.Configuration;

import android.view.MotionEvent;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MenuInflater;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.view.LayoutInflater;
import android.view.ViewGroup;
import android.view.KeyEvent;
import android.view.View.OnKeyListener;

import java.io.IOException;

import android.os.Message;
import android.os.Handler;
import android.os.Environment;

import java.lang.Double;

import android.graphics.Canvas;
import com.best.data.GTStore;
import com.best.util.Funcs;
import com.best.util.TransitionEffect;

import android.widget.RelativeLayout;

public class Find extends ListActivity  {

	public static ListActivity me;
	public static Context m_context;
	public static AttributeSet attr;
	public static LayoutInflater mInflater;
	
	public static int M_FROM_LIST_CAPTION = 1;
	public static int M_TO_LIST_CAPTION = 2;
	public static int M_FROM_NEAR_BY_LIST_CAPTION = 3;
	public static int M_TO_NEAR_BY_LIST_CAPTION = 4;
	public static int WIDGET_VISIBLE = 0;
	public static int WIDGET_INVISIBLE = 4;
	
	public static String[] stopsId ;
	public static String[] stopName;
	public static String[] distance;
	public static String[] stopLatitude;
	public static String[] stopLongitude;
	public static String[][] resultTemp;

	public static int selPosition = 0;
	public static int flagSourceSel = -1;
	public static int flagDestSel = -1;
	public static int listDisplayed = -1;
	public static boolean flagPanelVisible = true;
	
	public static String _sourceStopId = null;
	public static String _destStopId = null;
	
	public static Double latDouble=0.0;
	public static Double longDouble=0.0;
	
	public static ProgressDialog dialog;
	
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate( savedInstanceState );
		
		if (android.os.Build.VERSION.SDK_INT > android.os.Build.VERSION_CODES.DONUT) 
			TransitionEffect.callOverridePendingTransition(this);
			
		//overridePendingTransition(R.anim.fade_in, R.anim.fade_out);
		me = this;
		m_context = this;
		me.setContentView( com.best.ui.R.layout.find );
		flagSourceSel=-1;
		flagDestSel=-1;
		init();
	}
	
	@Override
    protected void onSaveInstanceState(final Bundle outState) {
		outState.putInt("src",flagSourceSel);
		outState.putInt("dest",flagDestSel);
		outState.putInt("listDisplay",listDisplayed);
    }
  
   @Override
    protected void onRestoreInstanceState(final Bundle outState) {
		if(outState.getInt("listDisplay")!=-1)
		{
			EfficientAdapter adapter = new EfficientAdapter( m_context,resultTemp);
			me.setListAdapter( adapter );
			( (TextView) me.findViewById(com.best.ui.R.id.txthead) ).setVisibility( WIDGET_VISIBLE );
			//((ImageButton) me.findViewById(com.best.ui.R.id.expandable)).setVisibility( WIDGET_VISIBLE );
		}
		flagSourceSel=outState.getInt("src");
		flagDestSel=outState.getInt("dest");
    }
 
	@Override
    public void onConfigurationChanged(Configuration newConfig) {

        // do something or nothing when configuration change.
        super.onConfigurationChanged(newConfig);
		init();
    }
	
	@Override
    protected void onResume() {
        super.onResume();
    }

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(com.best.ui.R.menu.menustart, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		// Handle item selection
		switch (item.getItemId()) {
			case com.best.ui.R.id.mnuexitmain:
				Best.exit( me );
				return true;
			default:
				return super.onOptionsItemSelected(item);
		}
	}
	
    @Override
    protected void onPause() {
		super.onPause();
        // cancelUpdatePosition();
    }
	
	@Override
	public void onBackPressed() {
		Best.exit( me );
		//return;
	}
	
	public void handleFromSearch(String fromTxt)
	{
		if( fromTxt.length() > 0 )
		{
			if( fromTxt.length() > 2 )
				findBusStops( false, fromTxt, M_FROM_LIST_CAPTION );
			else
				Best.showError( m_context, com.best.ui.R.string.errMsgMoreChar );
		}
		else
			Best.showError( m_context, com.best.ui.R.string.errMsgEnterSrcLoc );
	}
	
	public void handleToSearch(String toTxt)
	{
		if(toTxt.length()>0)
		{
			if(toTxt.length()>2)
				findBusStops( false, toTxt, M_TO_LIST_CAPTION );
			else
				Best.showError( m_context, com.best.ui.R.string.errMsgMoreChar );
		}
		else
			Best.showError( m_context, com.best.ui.R.string.errMsgEnterDestLoc );
	}
	
	public void handleEnter(KeyEvent e,EditText txt,boolean frmSearch)
	{
		if( e.getKeyCode() == KeyEvent.KEYCODE_ENTER && e.getAction() == KeyEvent.ACTION_DOWN) //enter
		{
			if( frmSearch )
				handleFromSearch( txt.getText().toString().trim() );
			else	
				handleToSearch( txt.getText().toString().trim() );
		}
	}
	
	public void init()
	{
		final TextView txthead = (TextView) me.findViewById(com.best.ui.R.id.txthead);
		//final LinearLayout expLayout = (LinearLayout) me.findViewById(com.best.ui.R.id.explinearlayout);
		
		// final ImageButton btnexpand = (ImageButton) me.findViewById(com.best.ui.R.id.expandable);
		// btnexpand.setOnClickListener(new View.OnClickListener() {
			// public void onClick(View v) {
				// if(flagPanelVisible == true)
				// {
					 // expLayout.setVisibility(LinearLayout.GONE);
					 // flagPanelVisible = false;
					 // btnexpand.setImageResource(R.drawable.ic_plus_trans);
				// }
				// else
				// {
					 // expLayout.setVisibility(LinearLayout.VISIBLE);
					 // flagPanelVisible = true;
					 // btnexpand.setImageResource(R.drawable.ic_minus_trans);
				// }	
			// }	
		// });
		
		final EditText txtFrm = (EditText) me.findViewById(com.best.ui.R.id.fromtxt); 
		 txtFrm.setOnKeyListener( new OnKeyListener() {
			public boolean onKey(View v, int keyCode, KeyEvent event) {
				handleEnter( event, txtFrm, true );
				return false;
			}
		}); 
		
		final ImageButton btnsearchfrm = (ImageButton) me.findViewById(com.best.ui.R.id.findfrom);
		btnsearchfrm.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				handleFromSearch( txtFrm.getText().toString().trim() );
			}	
		});
		
		final EditText txtTo = (EditText) me.findViewById(com.best.ui.R.id.totxt); 
		 txtTo.setOnKeyListener( new OnKeyListener() {
			public boolean onKey(View v, int keyCode, KeyEvent event) {
				handleEnter( event, txtTo, false );
				return false;
			}
		}); 
		
		final ImageButton btnsearchto = (ImageButton) me.findViewById(com.best.ui.R.id.findto);
		btnsearchto.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				handleToSearch( txtTo.getText().toString().trim() );
			}	
		});
		
		final Button btnnearfrom = (Button) me.findViewById(com.best.ui.R.id.nearFrom);
		btnnearfrom.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				findNearByStops( true );
			}	
		});
			
		final Button btnnearto = (Button) me.findViewById(com.best.ui.R.id.nearTo);
		btnnearto.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				findNearByStops( false );
			}	
		});
		
		final Button btnfindbus = ( Button ) me.findViewById( com.best.ui.R.id.findbus );
		btnfindbus.setOnClickListener( new View.OnClickListener() {
			public void onClick(View v) {
			
				String sourceText = txtFrm.getText().toString();
				String destText = txtTo.getText().toString();
				if( sourceText.length() > 0 )
				{
					if( flagSourceSel != -1 )
					{
						if( destText.length() > 0 )
						{
							if( flagDestSel != -1 )
							{
								Best.showProcessing( m_context, "Searching","Please wait while searching.." );
								RouteSearchThread searchRoute = new RouteSearchThread( searchRoutesHandler );
								searchRoute.start();
							}
							else
								Best.showError( m_context, com.best.ui.R.string.errMsgEnterValidDest );
						}
						else
							Best.showError( m_context, com.best.ui.R.string.errMsgEnterDestLoc );
					}
					else
						Best.showError( m_context, com.best.ui.R.string.errMsgEnterValidSrc );
				}
				else
					Best.showError( m_context, com.best.ui.R.string.errMsgEnterSrcLoc );
			}
		});	
	}
	
	public Handler searchRoutesHandler = new Handler() {
        public void handleMessage(Message msg) {
            Bundle dataBundle = msg.getData();
			
			Best.dissmissProcessing();
			
			String[][] routesResult = ( String[][] )dataBundle.getSerializable( "rts" );
			
			EfficientAdapter adapter = new EfficientAdapter( m_context, routesResult );
			me.setListAdapter( adapter );
			ListView listview = ( ListView )me.findViewById( android.R.id.list );
			listview.requestLayout();
		
			if( routesResult != null && routesResult.length >0 )
			{
				( (TextView) me.findViewById(com.best.ui.R.id.txthead) ).setVisibility( WIDGET_VISIBLE );
				( ( ListView )me.findViewById( android.R.id.list ) ).setVisibility( WIDGET_VISIBLE );
				//((ImageButton) me.findViewById(com.best.ui.R.id.expandable)).setVisibility( WIDGET_VISIBLE );
				listDisplayed = 1;
			}
			 else
			{	( (TextView) me.findViewById(com.best.ui.R.id.txthead) ).setVisibility( WIDGET_INVISIBLE );
				( ( ListView )me.findViewById( android.R.id.list ) ).setVisibility( WIDGET_INVISIBLE );
				//((ImageButton) me.findViewById(com.best.ui.R.id.expandable)).setVisibility( WIDGET_INVISIBLE );
				Best.showMessage( m_context, "There are no routes to show.", "Processing" );	
			}
		
        }
    };
	
	private class RouteSearchThread extends Thread 
	{
        Handler _handler;
        
		RouteSearchThread(Handler handler ) 
		{
            _handler = handler;
        }
       
        public void run() 
		{
			//code to get all routes
			Bundle dataBundle = new Bundle(); 
			String currTime = Funcs.getCurrentTime( true );
			// dataBundle.putSerializable( "rts", GTStore.getRoutes( _sourceStopId, _destStopId, Funcs.getCurrentDay(), currTime, Funcs.addTime( currTime, "00:25:00" ) ) );
			
			//dataBundle.putSerializable( "rts", GTStore.findRoutes( 40.44938, -3.6912, 40.41876, -3.69263, Funcs.getCurrentDay() ) );
			
			dataBundle.putSerializable( "rts", GTStore.getDirectRoutes( _sourceStopId, _destStopId ) );
		
			//dataBundle.putSerializable( "rts", GTStore.getDirectRoutes( "714", "736" ) );
			//dataBundle.putSerializable( "rts", GTStore.getDirectRoutes( "46", "73" ) );
			
			Message msg = _handler.obtainMessage();
			msg.setData( dataBundle );
			_handler.sendMessage( msg );
        }
    }
	
	public void findNearByStops(boolean fromButton)
	{
		if( Best.checkGPS( m_context ) )
		{
			if( fromButton )
				findBusStops( true, "", M_FROM_NEAR_BY_LIST_CAPTION );
			else
				findBusStops( true, "", M_TO_NEAR_BY_LIST_CAPTION );
		}		
	}
	
	public static Handler searchStopsHandler = new Handler() {
        public void handleMessage(Message msg) {
            Bundle dataBundle = msg.getData();
			
			String[][] resultSet = (String[][]) dataBundle.getSerializable( "resultSet" );
			boolean byPosition = dataBundle.getBoolean( "byPosition" );
			boolean allOK = dataBundle.getBoolean( "allOK" );
			int editBox = dataBundle.getInt( "editBox" );
			
			Best.dissmissProcessing();
			
			if( allOK )
			{
				if( resultSet!=null && resultSet.length > 0 )
					displayList( resultSet, editBox );
				else
				{
					if( byPosition )
						Best.showMessage( m_context, com.best.ui.R.string.errMsgNoNearbyStop, "Searching" );
					else
						Best.showMessage( m_context, com.best.ui.R.string.errMsgNoStopsMatch, "Searching" );
				}	
			}
			else
				Best.showMessage( m_context, "Sorry something went wrong.", "Processing" );
        }
    };
	
	private class StopSearchThread extends Thread
	{
        Handler _handler;
        String _txtSearch = "";
		boolean _byPosition = false;
		int _editBox = -1;
		
		
		StopSearchThread(Handler handler, String txtSearch, boolean byPosition, int editBox ) 
		{
            _handler = handler;
			_txtSearch = txtSearch;
			_byPosition = byPosition;
			_editBox = editBox;
        }
       
        public void run() 
		{
			boolean allOK = true;
			String[][] resultSet = null;
			
			if( Best.m_latitude.length() > 0 && Best.m_longitude.length() > 0 )
			{
				latDouble = Double.valueOf( Best.m_latitude );//Double.valueOf( "40.45939" );
				longDouble = Double.valueOf( Best.m_longitude );//Double.valueOf( "-3.78429" );
			}	
			
            if( _byPosition )
			{
				//near by stops
				try{
					resultSet = GTStore.getNearByStops( latDouble, longDouble );
				}catch(Exception e){System.out.println("Excp2: " + e.toString() );allOK = false;}
			}
			else
			{
				//search by inputtext
				try{
					resultSet = GTStore.getAllStopsByText( _txtSearch, latDouble, longDouble );
				}catch(Exception e){allOK = false; e.printStackTrace();}
			}
			
			Bundle dataBundle = new Bundle(); 
			dataBundle.putSerializable( "resultSet", resultSet );
			dataBundle.putBoolean( "byPosition", _byPosition );
			dataBundle.putBoolean( "allOK", allOK );
			dataBundle.putInt( "editBox", _editBox );
			
			Message msg = _handler.obtainMessage();
			msg.setData( dataBundle );
			_handler.sendMessage( msg );
        }
    }
	
	public void findBusStops(boolean byPosition, String enteredText, int editBoxNo)
	{
		Best.showProcessing( m_context, "Searching","Please wait while searching.." );
		StopSearchThread thread = new StopSearchThread( searchStopsHandler, enteredText, byPosition, editBoxNo );
		thread.start();
	}
	
	@Override 
	public void onActivityResult(int requestCode, int resultCode, Intent data) {   
	
		super.onActivityResult(requestCode, resultCode, data); 
		try{
			Bundle bundle = data.getExtras();
			int editBoxNo=bundle.getInt( "EditText" );
			selPosition=bundle.getInt( "position" );
			
			if( editBoxNo == 1 || editBoxNo == 3 )
			{
				String FrmLoc=bundle.getString( "frmLoc" );
				EditText txtfrm1 = ( EditText ) findViewById(com.best.ui.R.id.fromtxt); 
				txtfrm1.setText(FrmLoc);
				flagSourceSel = selPosition;
				_sourceStopId = bundle.getString( "stopId" );
			}
			else if(editBoxNo==2||editBoxNo==4)
			{
				String ToLoc=bundle.getString("frmLoc");
				EditText txtTo1 = (EditText) findViewById(com.best.ui.R.id.totxt); 
				txtTo1.setText(ToLoc);
				flagDestSel = selPosition;
				_destStopId = bundle.getString( "stopId" );
			}
		}
		catch(Exception e)
		{
			System.out.println("Exception-"+e.toString());
		}		
	}
	
	public static void displayList(String[][] resultSet,int editBoxNo)
	{
		try{
				String[] stopsId, stopName, distance;
				stopsId = new String[resultSet.length ];
				stopName = new String[resultSet.length ];
				distance = new String[resultSet.length ];
				
				for(int index=0; index<resultSet.length; index++)
				{
					if( resultSet[ index ] != null && resultSet[ index ].length > 0 )
					{
						String[] stopDesc = (String[])(resultSet[ index ]);
						stopsId[ index ] = stopDesc[0];
						stopName[ index ] = stopDesc[1];
						distance[ index ] = stopDesc[2];
						Best.log( "ID : "+stopsId[ index ].toString()+" -- "+stopName[ index ].toString()+" --- "+distance[ index ].toString() );
					}
				}
			
				Intent intent = new Intent(m_context, ListLocation.class);  
				Bundle bundle = new Bundle(); 
				bundle.putStringArray( "StopID", stopsId );
				bundle.putStringArray( "Stops", stopName );
				bundle.putStringArray( "Distance", distance );
				bundle.putInt( "EditText", editBoxNo );
				intent.putExtras( bundle );
				me.startActivityForResult( intent, 5 );
		}
		catch(Exception e){}
	}

	public class EfficientAdapter extends BaseAdapter implements Filterable {
	
		public String[][] result;
		
		public EfficientAdapter(Context context, String[][] resultSet)
		{
			if(resultSet!= null)
			{
				mInflater = LayoutInflater.from( context );
				result = new String[resultSet.length][];
				result=resultSet;
			}
		}

		public View getView(final int position, View convertView, ViewGroup parent) {

			ViewHolder holder;
			if(result!= null)
			{
				if (convertView == null)
				{	
					convertView = mInflater.inflate(com.best.ui.R.layout.list_button, null);
				
					holder = new ViewHolder();
					holder.routename= (TextView) convertView.findViewById(com.best.ui.R.id.routename);
					holder.head = (TextView) convertView.findViewById(com.best.ui.R.id.bushead);
					holder.total_dist = (TextView) convertView.findViewById(com.best.ui.R.id.totaldist);
					holder.no_of_stops = (TextView) convertView.findViewById(com.best.ui.R.id.stopsno);
					holder.blue_bus = (ImageView) convertView.findViewById(com.best.ui.R.id.busBlue);
					convertView.setOnClickListener(new OnClickListener() {
					 
						@Override
						public void onClick(View v) {
							
							Bundle bundle = new Bundle();
							bundle.putString( "tripID" , result[position][0] );
							bundle.putString( "sourceID" ,_sourceStopId);
							bundle.putString( "destID" ,_destStopId);
							bundle.putBoolean( "showFullRoute" ,false);
							Intent intent = new Intent(m_context, Routes.class);  
							intent.putExtras( bundle );
							me.startActivityForResult(intent,6);
						
					}
					});
					
					convertView.setTag(holder);
				} 
				else 
					holder = (ViewHolder) convertView.getTag();
				
				String _routeName = result[position][1];
				String _headerName = result[position][2];
				String _betweenStopsNum = result[position][3];
				int _distance = 0;
				try{ _distance = Integer.parseInt( result[position][4] ); }catch(Exception e){}
				
				holder.routename.setText( _routeName );
				holder.head.setText( _headerName );
				if( _distance > 1000)
				{
					if( _distance == 0 )
					{
						holder.total_dist.setText( "NA");
					}
					else
					{
						String dist = Double.toString(Funcs.roundDouble((Double.parseDouble(_distance+"")/1000), 1));
						holder.total_dist.setText( dist +" km");
					}	
				}
				else
					holder.total_dist.setText( _distance +" m");
				
				if( _betweenStopsNum == null )
				{
					holder.no_of_stops.setText( "NA" );
				}
				else
				{
					if(Integer.parseInt(_betweenStopsNum) == 1)
						holder.no_of_stops.setText( _betweenStopsNum + " Bus stop" );
					else
						holder.no_of_stops.setText( _betweenStopsNum + " Bus stops" );
				}		
				return convertView;
			}
			return (null);
		}
			
		public class ViewHolder {
		TextView routename;
		TextView head;
		ImageView blue_bus;
		TextView total_dist;
		TextView no_of_stops;
		}
				 
		@Override
		public Filter getFilter() {
			return null;
		}
		 
		@Override
		public int getCount() {
			if(result != null)
				return result.length;
			else
				return 0;
		}
				 
		@Override
		public Object getItem(int position) {
			if(result != null)
				return result[position];
			else
				return (null);
		}
		
		@Override
		public long getItemId(int position) {
			return 0;
		}			 
	}
	
	
}

 